//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

struct weircdgline {
	unsigned char* mask;
	long long expiretime;
	unsigned char* reason;
};
struct weircdgline* glines[COMPILEOPTION_MAXGLINES];
int glines_inited = 0;
void initglines() {
	if (glines_inited == 1) {return;}
	glines_inited = 1;
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		glines[k] = NULL;
		k++;
	}
}
void freeglines() {
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			free(glines[k]->mask);
			free(glines[k]->reason);
			free(glines[k]);
			glines[k] = NULL;
		}
		k++;
	}
}
int readglines() { //read glines from gline.db
	initglines();
	freeglines();
	int k;
	FILE *r = fopen(cuo.glinefilepath,"r");
	if (!r) {printf("%s    > gline file not existant yet\n",startupprefixsub);return 0;}//file is just not created yet, so we don't have any glines
	unsigned char line[300];
	unsigned char tmp[300];
	unsigned char tmp2[300];
	long long exp;k = -1;
	while (fgets(line, 300, r) != NULL) {
		if (strlen(line) > 0) {
			if (charpos(line,'!') <= 0) {
				fclose(r);return -1;
			}
			if (charpos(line,' ') <= charpos(line,'!')) {
				fclose(r);return -1;
			}
			strcpy(tmp,line);
			tmp[charpos(tmp,' ')] = 0;cut(line,charpos(line,' ')+1);
			if (charpos(line,' ') <= 0) {
				fclose(r);return -1;
			}
			strcpy(tmp2,line);
			tmp2[charpos(tmp2,' ')] = 0;cut(line,charpos(line,' ')+1);
			exp = atoll(tmp2);if (exp < 0) {fclose(r);return -1;}
			trimleft(line);
			if (strlen(line) <= 0) {fclose(r);return -1;}
			k++;
			glines[k] = malloc(sizeof(struct weircdgline));
			if (glines[k] == NULL) {
				printf("!!! Memory allocation failed\n");
				fclose(r);return -1;
			}
			memset(glines[k],0,sizeof(struct weircdgline));
			glines[k]->mask = malloc(strlen(tmp)+1);
			if (glines[k]->mask == NULL) {
				printf("!!! Memory allocation failed\n");
				free(glines[k]);
				glines[k] = NULL;
				fclose(r);return -1;
			}
			glines[k]->reason = malloc(strlen(line)+1);
			if (glines[k]->reason == NULL) {
				printf("!!! Memory allocation failed\n");
				free(glines[k]);
				free(glines[k]->mask);
				glines[k] = NULL;
				fclose(r);return -1;
			}
			glines[k]->expiretime = exp;
			strcpy(glines[k]->mask,tmp);
			strcpy(glines[k]->reason,line);
			if (strlen(glines[k]->reason) > 499) {fclose(r);return -1;}
			if (k >= COMPILEOPTION_MAXGLINES-1) {break;}
		}
	}
	fclose(r);
	printf("%s    > %d gline(s) loaded\n",startupprefixsub,k+1);
	return 0;
}
unsigned char printexpbuf[200];
unsigned char* printexp(long long time) {
	if (time < 0) {time = 1;}
	int days = 0;
	int hours = 0;
	int minutes = 0;
	int seconds = 0;
	if (time == 0) {strcpy(printexpbuf,"never");return printexpbuf;}
	while (time >= 24*60*60) {
		days += 1;
		time -= 24*60*60;
	}
	while (time >= 60*60) {
		hours += 1;
		time -= 60*60;
	}
	while (time >= 60) {
		minutes += 1;
		time -= 60;
	}
	seconds = time;
	unsigned char tmp[20];
	strcpy(printexpbuf,"after ");
	if (minutes > 3 || hours > 0 || days > 0) {seconds = 0;}
	if (days > 0) {minutes = 0;}
	if (days > 20) {hours = 0;}
	if (days > 0) {sprintf(tmp,"%dd",days);strcat(printexpbuf,tmp);}
	
	if (hours > 0) {sprintf(tmp,"%dh",hours);strcat(printexpbuf,tmp);}
	
	if (minutes > 0) {sprintf(tmp,"%dm",minutes);strcat(printexpbuf,tmp);}
	
	if (seconds > 0 || (days == 0 && hours == 0 && minutes == 0)) {sprintf(tmp,"%ds",seconds);strcat(printexpbuf,tmp);}
	
	return printexpbuf;
}
void listglines(int uid) {
	initglines();
	unsigned char response[500];
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (glines[k]->expiretime != 0) {
				snprintf(response,499,":%s NOTICE %s :Gline: %s (%s): %s",cuo.svd,un(uid),glines[k]->mask,printexp(glines[k]->expiretime-time(NULL)),glines[k]->reason);
			}else{
				snprintf(response,499,":%s NOTICE %s :Gline: %s (%s): %s",cuo.svd,un(uid),glines[k]->mask,printexp(0),glines[k]->reason);
			}
			response[499] = 0;
			vsnd(response,uid);
		}
		k++;
	}
	snprintf(response,499,":%s NOTICE %s :End of GLine list",cuo.svd,un(uid));
	response[499] = 0;
	vsnd(response,uid);
}
void saveglines() {
	initglines();
	FILE *r = fopen(cuo.glinefilepath,"w");
	if (!r) {return;}//bad, but nothing we can do
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			fprintf(r,"%s %d %s",glines[k]->mask,glines[k]->expiretime,glines[k]->reason);
		}
		k++;
	}
	fclose(r);
}
int parsetime(const unsigned char* timestr,long long* tg) {
	int r = 0;int k;
	if (strcasecmp(timestr,"0") == 0) {*tg = 0;return 0;}
	if (strlen(timestr) <= 1) {return -1;}
	*tg = 0;
	r = strlen(timestr)-1;
	unsigned char type;
	while (r >= 0) {
		if (timestr[r] != 'd' && timestr[r] != 'h' && timestr[r] != 'm' && timestr[r] != 's') {
			return -1;
		}
		type = timestr[r];
		r--;
		k = 0;
		while (r >= 0) {
			if (timestr[r] >= '0' && timestr[r] <= '9') {
				if (type == 'd') {*tg += 24*60*60*(timestr[r]-'0')*(k+1);}
				if (type == 'h') {*tg += 60*60*(timestr[r]-'0')*(k+1);}
				if (type == 'm') {*tg += 60*(timestr[r]-'0')*(k+1);}
				if (type == 's') {*tg += (timestr[r]-'0')*(k+1);}
			}else{
				if (k == 0) {return -1;}break;
			}
			k++;
			r--;
		}
		if (k == 0) {return -1;}
	}
	return 0;
}
void glineusers(const unsigned char* mask, int ircop, const unsigned char* reason) {
	unsigned char umask[500];
	unsigned char longreason[500];
	snprintf(longreason,499,"G-Line by %s: %s",un(ircop),reason);
	longreason[499] = 0;
	int k = 0;
	while (k < userslotcount) {
		if (userpointers[k] != NULL && userpointers[k]->authed == true && userpointers[k]->pleaseremove == false) {
			snprintf(umask,499,"%s!%s@%s",un(k),userpointers[k]->suserid,userpointers[k]->host);
			umask[499] = 0;
			if (matches(umask,mask) == true) {
				userpointers[k]->quitreason = malloc(strlen(longreason) + 1);
				if (userpointers[k]->quitreason != NULL) {
					strcpy(userpointers[k]->quitreason,longreason);
					snprintf(longreason,499,"ERROR :Banned by %s: %s",un(k),reason);
					longreason[499] = 0;
					vsnd(longreason,k);
					userQuit(k,USERQUIT_ERROR);
				}
			}
		}
		k++;
	}
}
unsigned char glinedbuffer[500];
unsigned char* glined(int uid) {
	initglines();
	unsigned char umask[500];
	snprintf(umask,499,"%s!%s@%s",un(uid),userpointers[uid]->suserid,userpointers[uid]->host);
	umask[499] = 0;
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (matches(umask,glines[k]->mask) == true) {
				strcpy(glinedbuffer,glines[k]->reason);
				return glinedbuffer;
			}
		}
		k++;
	}
	return NULL;
}
unsigned char* glinedbyip(const unsigned char* ip) {
	initglines();
	unsigned char umask[500];
	snprintf(umask,499,"*!*@%s",ip);
	umask[499] = 0;
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (matches(umask,glines[k]->mask) == true) {
				strcpy(glinedbuffer,glines[k]->reason);
				return glinedbuffer;
			}
		}
		k++;
	}
	return NULL;
}
void delgline(int uid, const unsigned char* mask) {
	unsigned char newmask[MAXUSERMASKLEN+1];
	strncpy(newmask,mask,MAXUSERMASKLEN);
	newmask[MAXUSERMASKLEN] = 0;
	makevalidmask(newmask);
	initglines();
	unsigned char response[500];
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (strcasecmp(glines[k]->mask,newmask) == 0) {
				snprintf(response,499,"%c%s removes gline on %s%c",2,un(uid),glines[k]->mask,2);
				response[499] = 0;
				IOnotice(response);
				free(glines[k]->mask);
				free(glines[k]->reason);
				free(glines[k]);
				glines[k] = NULL;
				return;
			}
		}
		k++;
	}
	snprintf(response,499,":%s NOTICE %s :GLine %s not found.",cuo.svd,un(uid),mask);
	response[499] = 0;
	vsnd(response,uid);
	return;
}
void addgline(int uid, const unsigned char* mask, const unsigned char* vtime, const unsigned char* vreason) {
	initglines();
	unsigned char response[500];
	unsigned char reason[500];
	strncpy(reason,vreason,499);reason[499] = 0;
	trimleft(reason);trimright(reason);
	if (strlen(reason) < 1) {
		snprintf(response,499,":%s NOTICE %s :Please always give a reason for g-line.",cuo.svd,un(uid));
		response[499] = 0;
		vsnd(response,uid);
		return;
	}
	long long exp;
	if (strlen(reason) <= 0) {
		return;
	}
	if (parsetime(vtime,&exp) < 0) {
		snprintf(response,499,":%s NOTICE %s :Invalid expiration time value. '5d2h' (5 days, 2 hours) or similar expected ('0' for never).",cuo.svd,un(uid));
		response[499] = 0;
		vsnd(response,uid);
		return;
	}
	unsigned char valmask[MAXUSERMASKLEN+1];
	if (valmask == NULL) {
		snprintf(response,499,":%s NOTICE %s :Gline failed: Out of memory",cuo.svd,un(uid));
		response[499] = 0;
		vsnd(response,uid);
		return;
	}
	strncpy(valmask,mask,MAXUSERMASKLEN);valmask[MAXUSERMASKLEN] = 0;
	makevalidmask(valmask);
	unsigned char umask[900];
	sprintf(umask,"%s!%s@%s",un(uid),userpointers[uid]->suserid,userpointers[uid]->host);
	if (matches(umask,valmask) == true) {
		snprintf(response,499,":%s NOTICE %s :You cannot gline yourself.",cuo.svd,un(uid));
		response[499] = 0;
		vsnd(response,uid);
		return;
	}
	unsigned char renews[12] = "sets";
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (strcasecmp(glines[k]->mask,valmask) == 0) {
				strcpy(renews,"refreshes");
				free(glines[k]->reason);
				free(glines[k]->mask);
				free(glines[k]);
				glines[k] = NULL;
				break;
			}
		}
		k++;
	}
	k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] == NULL) {
			glines[k] = malloc(sizeof(struct weircdgline));
			if (glines[k] == NULL) {
				snprintf(response,499,":%s NOTICE %s :Gline failed: Out of memory",cuo.svd,un(uid));
				response[499] = 0;
				vsnd(response,uid);
				return;
			}
			memset(glines[k],0,sizeof(struct weircdgline));
			glines[k]->mask = malloc(strlen(valmask)+1);
			glines[k]->reason = malloc(strlen(reason)+1);
			if (glines[k]->mask == NULL || glines[k]->reason == NULL) {
				if (glines[k]->mask != NULL) {free(glines[k]->mask);}
				if (glines[k]->reason != NULL) {free(glines[k]->reason);}
				free(glines[k]);
				snprintf(response,499,":%s NOTICE %s :Gline failed: Out of memory",cuo.svd,un(uid));
				response[499] = 0;
				vsnd(response,uid);
				return;
			}
			strcpy(glines[k]->mask,valmask);
			strcpy(glines[k]->reason,reason);
			if (exp > 0) {
				glines[k]->expiretime = time(NULL) + exp;
			}else{
				glines[k]->expiretime = 0;
			}
			snprintf(response,499,"%c%s %s gline on %s%c (expires %s)",2,un(uid),renews,valmask,2,printexp(exp));
			response[499] = 0;
			IOnotice(response);
			glineusers(valmask,uid,reason);
			return;
		}
		k++;
	}
	snprintf(response,499,":%s NOTICE %s :Gline failed: Already too many glines",cuo.svd,un(uid));
	response[499] = 0;
	vsnd(response,uid);
	return;
}
void expireglines() {
	initglines();
	int k = 0;
	while (k < COMPILEOPTION_MAXGLINES) {
		if (glines[k] != NULL) {
			if (glines[k]->expiretime != 0) {
				if (glines[k]->expiretime < time(NULL)) {
					free(glines[k]->mask);
					free(glines[k]->reason);
					free(glines[k]);
					glines[k] = NULL;
				}
			}
		}
		k++;
	}
}

